<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: i18n.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: i18n.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * developing enterprise application software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2015 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

/**
 *
 * This module provides a collection of utility methods for internationalization.
 *
 * ##### Usage
 *     var locale = {
 *         language: "zh",
 *         country: "TW"
 *     };
 *
 *     var options = {
 *         locale: locale,
 *     };
 *     expect(i18n.translate("Purchase Order", options)).to.equal("採購單");
 *     expect(i18n.translate("total: ${0} records", options)).to.equal("總計：${0} 筆記錄");
 *
 *     options.namespace = "message";
 *     expect(i18n.translate("Please select one record.", options)).to.equal("請選擇一筆記錄．");
 *
 *     i18n.locale(locale);
 *     expect(i18n.locale()).to.deep.equal(locale);
 *
 *     expect(i18n.translate("Purchase Order")).to.equal("採購單");
 *
 * @module i18n
 * @author  Jason Lin
 * @since   1.0
 */

define(['underscore', 'uweaver/browser', 'i18next'], function (_, browser, i18next) {
    var DEFAULTPATTERN = {
        'date': "yyyy-MM-dd",
        'datetime': "yyyy-MM-dd HH:mm",
        'month': "yyyy-MM",
        'time': 'HH:mm'
    };
    /**
     * initialize the i18n module.
     *
     * @memberof module:i18n
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Object} [options.locale] - The locale for i18n.
     * @param {Object} [options.namespaces=['term', 'message']] - The message resources.
     * @param {Object} [options.fallback={language: 'en'}] - The fallback locale.
     */
    function initialize(options) {
        options || (options = {});

        var defaults = {
            locale: browser.locale(),
            namespaces: ['term', 'app', 'message', 'validation'],
            fallback: {language: 'en'}
        };

        _.defaults(options, defaults);

        var fallbackLng = options.fallback.language;
        (options.fallback.country) &amp;&amp; (fallbackLng = fallbackLng + '-' + options.fallback.country);

        var settings = {
            resGetPath: 'nls/__lng__/__ns__.json',
            fallbackLng: fallbackLng,
            detectLngQS: 'lang',
            getAsync: false,
            ns: {
                namespaces: options.namespaces,
                defaultNs: options.namespaces[0]
            },
            nsseparator: '::',
            keyseparator: '->'
        };


        i18next.init(settings);

        locale(options.locale);
    }

    /**
     * translate the words.
     *
     * @memberof module:i18n
     * @param {String|Object} words - the words to translate.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.locale] - The locale to use for translation.
     * @param {String} [options.namespace] - The namespace to lookup the translation.
     * @param {String} [options.defaultValue] - The default value to return when nothing match.
     * @returns {String|Object}
     */
    function translate(words, options) {
        options || (options = {});

        var defaults = {};

        _.defaults(options, defaults);

        if(typeof(words) === 'string') {
            return find(words, options);
        } else if(words instanceof Object) {
            var values = {};
            _.each(words, function (words, key) {
                if(words instanceof Object) {
                    values[key] = translate(words)
                } else {
                    values[key] = find(words, options);
                }
            });
            return values;
        }
    }

    function message(key, options) {
        options || (options = {});

        var defaults = {
            namespace: 'message'
        };

        _.defaults(options, defaults);

        return find(key, options);
    }

    function find(key, options) {
        options || (options = {});

        var lang = localeToLang(options.locale);

        return i18next.translate(key, {ns: options.namespace, lng: lang, defaultValue: options.defaultValue});
    }

    function localeToLang(locale) {
        if(!(locale &amp;&amp; locale.language)) return undefined;

        var lang = locale.language;

        (locale.country) &amp;&amp; (lang = lang + '-' + locale.country);

        return lang;
    }

    function langToLocale(lang) {
        var tokens = lang.split('-');
        return {
            language: tokens[0],
            country: tokens[1]
        };
    }

    /**
     * Get or set the locale of i18n.
     *
     * @memberof module:i18n
     * @param {Locale} locale - the locale.
     * @returns {Object|void}
     */
    function locale(locale) {
        var lng = i18next.lng();

        if(!locale) {
            return langToLocale(lng);
        }

        var lang = localeToLang(locale);

        if(lang===lng) return;

        i18next.setLng(lang);
    }


    /**
     * Get the datetime representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function datetimePattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: DEFAULTPATTERN['datetime']
        };

        var text = find('datetimePattern', options);

        return (text==="") ? null : text;

    }

    /**
     * Get the simple date representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function datePattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: DEFAULTPATTERN['date']
        };

        var text = find('datePattern', options);

        return (text==="") ? null : text;
    }

    /**
     * Get the time representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function timePattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: DEFAULTPATTERN['time']
        };

        var text = find('timePattern', options);

        return (text==="") ? null : text;
    }

    /**
     * Get the month representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function monthPattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: DEFAULTPATTERN['month']
        };

        var text = find('monthPattern', options);

        return (text==="") ? null : text;
    }

    /**
     * Get the number representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function numberPattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: ""
        };

        var text = find('numberPattern', options);

        return (text==="") ? null : text;
    }

    /**
     * Get the currency representation format.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function currencyPattern(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: ""
        };

        var text = find('currencyPattern', options);

        return (text==="") ? null : text;

    }

    /**
     * Get the decimal separator.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function decimalSeparator(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: ""
        };

        var text = find('decimalSeparator', options);

        return (text==="") ? null : text;
    }

    /**
     * Get the grouping separator.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function groupingSeparator(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: ""
        };


        var text = find('groupingSeparator', options);

        return (text==="") ? null : text;

    }

    /**
     * Get the currency sign.
     *
     * @memberof module:i18n
     * @param {Locale} [locale] - The locale to use for internalize.
     * @returns {String}
     */
    function currencySign(locale) {
        var options = {
            namespace: 'app',
            locale: locale,
            defaultValue: ""
        };

        var text = find('currencySign', options);

        return (text==="") ? null : text;
    }

    return {
        initialize: initialize,
        translate: translate,
        message: message,
        locale: locale,
        datePattern: datePattern,
        datetimePattern: datetimePattern,
        monthPattern: monthPattern,
        timePattern: timePattern,
        currencyPattern: currencyPattern,
        numberPattern: numberPattern,
        decimalSeparator: decimalSeparator,
        groupingSeparator: groupingSeparator,
        currencySign: currencySign
    };
});
</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
